#ifndef __MENU_H__
#define __MENU_H__

#include <oslib/oslib.h>
#include <vector>
#include "gfx.h"
#include "Game.h"
#include "Item.h"
#include "ProgressBar.h"
#include "Text.h"
#include "Emitter.h"

enum Fade {
  FadingIn,
  FadedIn,
  FadingOut,
  FadedOut,
};

class Menu
{
public:
  Menu();
  virtual ~Menu();
  void update(OSL_CONTROLLER* pad);
  void render();
  static const int MenuEntries = 5;
  static const int MenuOffsetX = 15;
  static const int MenuOffsetY = 8;
  static const int MenuItemSpacingY = 14;
  static const int CursorSize = 5;
private:
  void startGame();
  void showIntro();
  void selectNextItem();
  void selectPreviousItem();
  void setMode(int mode);
  Emitter _em;
  Game _game;
  std::vector<Item*> _items;
  ProgressBar *_speedBar, *_levelBar;
  Text *_modeText;
  OSL_SOUND *_validate, *_switch;
  OSL_IMAGE* _tile;
  int _fadeStatus;
  int _fadeAlpha;
  int _currentItem;
  int _mode;
};

#endif
